package aspectEditor.aspectEditorUtils;
import java.util.jar.JarFile;
import java.util.*;
import java.io.*;
import edu.neu.ccs.demeter.aplib.*;
import edu.neu.ccs.demeter.*;
class OnlyThrough extends NegativeConstraint {
  public OnlyThrough() { super(); }
  public OnlyThrough(GlobSpec glob) {
    super(glob);
  }
  public static OnlyThrough parse(java.io.Reader in) throws ParseException { return new Parser(in)._OnlyThrough(); }
  public static OnlyThrough parse(java.io.InputStream in) throws ParseException { return new Parser(in)._OnlyThrough(); }
  public static OnlyThrough parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
  void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
    super.universal_trv0_aft(_v_);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

  void __trav_checkConstraint_Node_SGEdge_trv_bef(__V_SGEdge_checkConstraint_Node __v0) {
    super.__trav_checkConstraint_Node_SGEdge_trv_bef(__v0);
  }

  void __trav_checkConstraint_Node_SGEdge_trv_aft(__V_SGEdge_checkConstraint_Node __v0) {
    super.__trav_checkConstraint_Node_SGEdge_trv_aft(__v0);
  }

  void __trav_checkConstraint_Node_SGEdge_trv(java.util.BitSet nodes, __V_SGEdge_checkConstraint_Node __v0) {
    __trav_checkConstraint_Node_SGEdge_trv_bef(__v0);
    { java.util.BitSet newnodes = new java.util.BitSet();
      newnodes.set(0);
      newnodes.and(nodes);
      if (!newnodes.equals(new java.util.BitSet())) {
        super.__trav_checkConstraint_Node_SGEdge_trv(newnodes, __v0);
      }
    }
    __trav_checkConstraint_Node_SGEdge_trv_aft(__v0);
  }

  void __trav_checkConstraint_Edge_SGEdge_trv_bef(__V_SGEdge_checkConstraint_Edge __v0) {
    super.__trav_checkConstraint_Edge_SGEdge_trv_bef(__v0);
  }

  void __trav_checkConstraint_Edge_SGEdge_trv_aft(__V_SGEdge_checkConstraint_Edge __v0) {
    super.__trav_checkConstraint_Edge_SGEdge_trv_aft(__v0);
  }

  void __trav_checkConstraint_Edge_SGEdge_trv(java.util.BitSet nodes, __V_SGEdge_checkConstraint_Edge __v0) {
    __trav_checkConstraint_Edge_SGEdge_trv_bef(__v0);
    { java.util.BitSet newnodes = new java.util.BitSet();
      newnodes.set(0);
      newnodes.and(nodes);
      if (!newnodes.equals(new java.util.BitSet())) {
        super.__trav_checkConstraint_Edge_SGEdge_trv(newnodes, __v0);
      }
    }
    __trav_checkConstraint_Edge_SGEdge_trv_aft(__v0);
  }

  void __trav_toGraph_PathDirective_trv_bef(__V_PathDirective_toGraph __v0) {
    super.__trav_toGraph_PathDirective_trv_bef(__v0);
  }

  void __trav_toGraph_PathDirective_trv_aft(__V_PathDirective_toGraph __v0) {
    super.__trav_toGraph_PathDirective_trv_aft(__v0);
  }

  void __trav_toGraph_PathDirective_trv(__V_PathDirective_toGraph __v0) {
    __trav_toGraph_PathDirective_trv_bef(__v0);
    super.__trav_toGraph_PathDirective_trv(__v0);
    __trav_toGraph_PathDirective_trv_aft(__v0);
  }

}
